当前位置:首页 > 资讯 > info6 > 正文

Java中自定义Exception异常

发表于: 2016-03-22   作者:chaplinlong   来源:转载   浏览:
摘要: Java中自定义的异常一般继承自Exception,这里就简单地说说。先通过继承自定义异常类。packagecn.defineException; //自定义异常:SeeWorld publicclassSeeWorldExceptionextendsException{ publicSeeWorldException(){ } publicSeeWorldException(Stringme

Java中自定义的异常一般继承自Exception,这里就简单地说说。
先通过继承自定义异常类。

package cn.defineException;

//自定义异常:SeeWorld
public class SeeWorldException extends Exception{
    public SeeWorldException(){

    }
    public SeeWorldException(String message){
        super(message);
    }
}

接着做几个测试类,在main方法中观察

package cn.defineException;

public class TestWorld {

    public void TestWorld1() throws SeeWorldException {
        throw new SeeWorldException("世界那么大,我想去看看。");

    }

    public void TestWorld2() {
        try {
            TestWorld1();
        } catch (SeeWorldException e) {
            RuntimeException re = new RuntimeException("你带上我,我带上钱。");
            re.initCause(e);
            throw re;
        }
    }

    /** * TestWorld1()抛出异常 TestWorld2()调用TestWorld1(),捕获异常,并包装成运行时异常。 * main方法中调用TestWorld1(),尝试捕获TestWorld2方法抛出的异常 * * @param args */
    public static void main(String[] args) {

        TestWorld t = new TestWorld();
        try {
            t.TestWorld2();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

}

这样就好了:看结果

java.lang.RuntimeException: 你带上我,我带上钱。
    at cn.defineException.TestWorld.TestWorld2(TestWorld.java:14)
    at cn.defineException.TestWorld.main(TestWorld.java:30)
Caused by: cn.defineException.SeeWorldException: 世界那么大,我想去看看。
    at cn.defineException.TestWorld.TestWorld1(TestWorld.java:6)
    at cn.defineException.TestWorld.TestWorld2(TestWorld.java:12)
    ... 1 more

Java中自定义Exception异常

编辑推荐
编程思想之异常处理 什么叫异常处理? 什么叫异常(Exception)?顾名思义就是非正常的情况,出现了不
一,异常的概念 :异常是程序运行期出现的错误。 二,异常的分类:a, 三,异常的捕获和处理 理解一
http://docs.oracle.com/javase/tutorial/essential/exceptions/definition.html Throwable Class a
本文是Exception处理的一篇不错的文章,从Java Exception的概念介绍起,依次讲解了Exception的类型
http://docs.oracle.com/javase/tutorial/essential/exceptions/definition.html Throwable Class a
http://docs.oracle.com/javase/tutorial/essential/exceptions/definition.html Throwable Class a
这方面主要有以下几种类型的题目: 1 try中throw一个exception,能否直接catch? public void metho
1. 异常机制 1.1 异常机制是指当程序出现错误后,程序如何处理。具体来说,异常机制提供了程序退出
public class ExceptionTest { public static void main(String [] args){ int result; Test test =
//仅作为学习笔记 /* 因为项目中会出现特有的问题 而这些问题并未被java所描述并封装对象 所以对于
版权所有 IT知识库 CopyRight © 2009-2015 IT知识库 IT610.com , All Rights Reserved. 京ICP备09083238号